; This is a modified version of UWCHEAT for EXE's modified by Origin's
; UW1PATCH.EXE game fix.

CODE    SEGMENT

        ASSUME  cs:CODE

        ORG     100h

First:  jmp     Start

        OldInt33        DD      ?

        UWDataSeg       DW      ?
        MouseFunc       DW      0
        InLoop          DB      0

        SegCheck        DB      0Ah, 00h, 8Ah, 05h
        CheckLen        EQU     ($-SegCheck)

Beep    MACRO

        push    ax
        push    cx

        mov     al, 10110110b
        out     43h, al
        mov     ax, 1000
        out     42h, al
        mov     al, ah
        out     42h, al
        in      al, 61h
        or      al, 3
        out     61h, al
        mov     cx, 5000

delay:
        loop    delay

        in      al, 61h
        and     al, 0FCh
        out     61h, al

        pop     cx
        pop     ax

ENDM

;*************************************************************************

NewInt33 PROC

        mov     MouseFunc,ax

        push    ax
        mov     ax,ds
        mov     UWDataSeg,ax
        pop     ax

        pushf
        call [OldInt33]

        cmp     MouseFunc,3
        je      ProcessInt      ; is this a call to check the mouse buttons?

        cmp     MouseFunc,5     ; is this a call to mouse button queue func?
        je      ProcessInt
        jmp     Done

ProcessInt:
        cmp     cx,4            ; is Column <= 4?
        jle     Test1
        jmp     Done

Test1:
        cmp     dx,196          ; is Row >= 196?
        jge     Test2
        jmp     Done

Test2:
        cmp     bx,0
        jne     ButtonPressed
        jmp     Done

ButtonPressed:
        mov     al,InLoop
        cmp     al,0
        je      Continue
        jmp     Done

Continue:
        mov     InLoop,1

        Beep

        ; Ok, if we made it past the two CMPs above, then the user has
        ; clicked the mouse in the upper right corner or the screen
        ; so push all the value so they won't be screwed when the mouse
        ; function returns

        push    ax
        push    bx
        push    cx
        push    dx
        push    ds
        push    es
        push    si
        push    di

        sti

        mov     es,UWDataSeg
        mov     es:[5726h+4880h],255          ; (512*78+92)
        mov     es:[5727h+4880h],30
        mov     es:[5728h+4880h],30
        mov     es:[5729h+4880h],30

        mov     di,73A9h+4880h          ; (512*92+180)

        mov     cx,20
        mov     al,01Eh                 ; set stats and skills to 30
        rep     stosb

        mov     cx,2
        mov     al,0FFh                 ; set vitality 255
        rep stosb

        mov     cx,2
        mov     al,07Fh                 ; set mana to 127
        rep stosb

ExitInt:
        mov     InLoop,0

        pop     di
        pop     si
        pop     es
        pop     ds
        pop     dx
        pop     cx
        pop     bx
        pop     ax

Done:
        iret

NewInt33 ENDP

;*************************************************************************

Start   PROC
        mov     ah,09h
        mov     dx,OFFSET Author
        int     21h

        mov     ah,35h            ; get the old interrupt vector
        mov     al,33h
        int     21h

        mov     word ptr OldInt33,bx      ; store the old interrupt vector
        mov     word ptr OldInt33 [2],es

        mov     di,bx             ; Point to the start of the int vector
        mov     si,OFFSET NewInt33
        mov     cx,(Start - NewInt33)

        repe    cmpsb
        jne     NotLoaded

        mov     ah,09h
        mov     dx,OFFSET Loaded
        int     21h

        lds     dx,es:OldInt33     ; restore original interrupt
        mov     ah,25h
        mov     al,33h
        int     21h

        pop     ds                ; restore program DS
        push    es                ; save TSR program segment
        mov     bx,es             ; and copy to BX
        mov     ax,es:2Ch         ; get TSR's environment segment to AX
        push    ax                ; save it
        dec     ax                ; get memory control block's segment
        mov     es,ax             ; to ES
        cmp     bx,es:[1]         ; check that environment block is still
                                  ; owned by TSR program block
        jne     fail              ; quit if not
        pop     es                ; restore TSR's environment segment
        mov     ah,49h            ; release memory
        int     21h
        jc      Fail              ; quit if it fails

        pop     es                ; restore TSR program segment
        mov     ah,49h            ; release memory
        int     21h

Fail:
        mov     ax,4C01h
        int     21h               ;terminate with exit code = 1

NotLoaded:
        mov     ax,cs
        mov     ds,ax
        mov     ax,2533h
        lea     dx,NewInt33
        int     21h

        mov     ah,09h
        mov     dx,OFFSET NotLoad
        int     21h

        mov     dx,OFFSET Start
        int     27h

Start   ENDP

Author  DB      10,13,'UWCHEAT for Ultima Underworlds, UW1PATCHed.',10,13
        DB      '  By Nelno the Amoeba',10,13,10,13,'$'

        NotLoad         DB      'UWCHEAT has gone resident...', 10,13,'$'

        Loaded          DB      'UWCHEAT removed from memory.', 10,13,'$'


CODE    ENDS

        END     First

